/*  Project partsasm
	Project Team DoGA
	Copyright (c) 1995. All Rights Reserved.

	TuVXe:    partsasm.apx Application
	t@C:        dselcol.cpp
	쐬:          Taka2


	Tv
	====
	TDSelColor (TDialog) ̃Cve[Vp̃\[Xt@C
*/

#include <owl\owlpch.h>
#pragma hdrstop

#include "dselcol.h"
#include "owl\radiobut.h"
#include "owl\edit.h"


//
// ̃AvP[Vŏ邷ׂẴbZ[W^R}h
// e[u쐬
//
DEFINE_RESPONSE_TABLE1(TDSelColor, TDialog)
//{{TDSelColorRSP_TBL_BEGIN}}
	EV_BN_CLICKED(IDOK, CmOK),
	EV_WM_PAINT,
	EV_WM_LBUTTONDOWN,
//{{TDSelColorRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{TDSelColor Implementation}}


TDSelColor::TDSelColor (TWindow* parent, int icolor, int ilight, int iwidth, int iheight):
	TDialog(parent, IDD_COLOR, 0)
{
	// INSERT>> RXgN^p̃R[h͂

	editwidth  = new TEdit(this, IDC_REND_WIDTH);
	editheight = new TEdit(this, IDC_REND_HEIGHT);

	selcolor = icolor;
	sellight = ilight;
	selwidth = iwidth;
	selheight = iheight;
	int i;
	for (i = 0; i < SELCOL_COLORS; ++i) {
		button[i] = new TRadioButton(this, IDC_COLOR_WH + i);
	}
	for (i = 0; i < SELCOL_LIGHTS; ++i) {
		lbutton[i] = new TRadioButton(this, IDC_LIGHT_LEFT + i);
	}
}


TDSelColor::~TDSelColor ()
{
	Destroy();

	// INSERT>> fXgN^p̃R[h͂

}


void TDSelColor::SetupWindow ()
{
	TDialog::SetupWindow();

    // INSERT>> ǉ̃R[h͂

	if (0 <= selcolor && selcolor < SELCOL_COLORS) {
		button[selcolor]->Check();
	}
	if (0 <= sellight && sellight < SELCOL_LIGHTS) {
		lbutton[sellight]->Check();
	}
	char mes[32];
	wsprintf(mes, "%d", selwidth);
	editwidth->SetText(mes);
	wsprintf(mes, "%d", selheight);
	editheight->SetText(mes);
}


void TDSelColor::CmOK ()
{
	// INSERT>> ǉR[h͂
	int i;
	for (i = 0; i < SELCOL_COLORS; ++i) {
		if (button[i]->GetCheck() == BF_CHECKED) {
			selcolor = i;
		}
	}
	for (i = 0; i < SELCOL_LIGHTS; ++i) {
		if (lbutton[i]->GetCheck() == BF_CHECKED) {
			sellight = i;
		}
	}
	int n;
	char mes[32];
	editwidth->GetText(mes, 32);
	n = atoi(mes);
	if (0 < n && n <= 2048) selwidth = n;

	editheight->GetText(mes, 32);
	n = atoi(mes);
	if (0 < n && n <= 2048) selheight = n;

	CloseWindow(IDOK);
}

void TDSelColor::EvPaint ()
{
    TDialog::EvPaint();

    // INSERT>> ǉR[h͂

    // INSERT>> ǉ̃R[h͂
	static TColor col[SELCOL_COLORS] = {
    					TColor::White,
                        TColor::LtBlue,
                        TColor::LtRed,
                        TColor::LtGreen,
                        TColor::LtMagenta};
	TClientDC dc(*this);

    int y1, y2;
	y1 = button[0]->Attr.Y - 12;
	y2 = y1+12;

	for (int i = 0; i < SELCOL_COLORS; ++i) {
		dc.SelectObject(TBrush(col[i]));
		dc.Rectangle(button[i]->Attr.X, y1,
					button[i]->Attr.X + button[i]->Attr.W,y2);
	}

}



void TDSelColor::EvLButtonDown (UINT modKeys, TPoint& point)
{
    TDialog::EvLButtonDown(modKeys, point);

    // INSERT>> ǉR[h͂

    int y1, y2;
	y1 = button[0]->Attr.Y - 12;
	y2 = y1+12;

	for (int i = 0; i < SELCOL_COLORS; ++i) {
		if (point.x >= button[i]->Attr.X
         && point.x <= button[i]->Attr.X + button[i]->Attr.W
		 && point.y >= y1 && point.y <= y2) {
			for (int j = 0; j < SELCOL_COLORS; ++j) {
            	if (i == j) {
                	button[j]->SetCheck(BF_CHECKED);
                } else {
                	button[j]->SetCheck(BF_UNCHECKED);
                }
            }
         }
	}
}

